#include "RangeSortSearchInt.h" //RangeSortSearchInt
#include "LegacyIntComparator.h" //LegacyIntComparator

/*!
 * \brief RangeSortSearchInt::showResult 搜索完毕，则显示结果。
 */
void RangeSortSearchInt::showResult()
{
    cout << endl << __FILE__ << ", " << __LINE__ << ", " << __func__ << ", finished search, time: " << QTime::currentTime ().toString ().toStdString () << endl; //Debug.
    
    cout << endl << __FILE__ << ", " << __LINE__ << ", " << __func__ << ", finished search, elapsed time: " << timing.elapsed() << "ms" << endl; //Debug.

    QList<int> result=rangeSortSearch.getResult(); //获取结果。

    cout << __FILE__ << ", " << __LINE__ << ", " << __func__ << ", got result: " << endl; //Debug.

    for(int currentValue:result)
    {
        cout << currentValue << ", ";
    } //for(int currentValue:result)

    cout << endl << __FILE__ << ", " << __LINE__ << ", " << __func__ << ", result over" << endl; //Debug.

    QCoreApplication::quit();
} //void RangeSortSearchInt::showResult()

void RangeSortSearchInt::main()
{
    QObject::connect(rangeSortSearch.getSignalProxy(),&PaSignalProxy::finished,this,&RangeSortSearchInt::showResult); //搜索完毕，则显示结果。

    QList<int> intList;

    cout << __FILE__ << ", " << __LINE__ << ", " << __func__ << ", generating integers" << endl; //Debug.

    for(auto intCounter=0;intCounter<100000000;intCounter++)
    {
        int currentRandomNumber=qrand() % 1000000000;

        intList << currentRandomNumber;
    } //for(auto intCounter=0;intCounter<100;intCounter++)

    cout << endl << __FILE__ << ", " << __LINE__ << ", " << __func__ << ", finished generating integers" << endl; //Debug.

    cout << endl << __FILE__ << ", " << __LINE__ << ", " << __func__ << ", start search, time: " << QTime::currentTime ().toString ().toStdString () << endl; //Debug.

    timing.start(); //开始计时。

    LegacyIntComparator *legacyIntComparator=new LegacyIntComparator;

    rangeSortSearch.startSearch(intList,legacyIntComparator,600);
}
